#!/usr/bin/perl -w
#...................................................................#
# Sanitarium WebLoG: web publish system.............................#
# Author: Green Kakadu (WebScript.Ru Network) ......................#
# Email: gnezdo@webscript.ru .......................................#
# WWW: http://webscript.ru .........................................#
# Copyright 2002 WebScript.Ru Network ( http://webscript.ru ).......#
# All Rights Reserved. .............................................#
#...................................................................#
#File Upload
#...................................................................#
use strict;
use CGI qw/:cgi/;
use CGI::Carp qw(fatalsToBrowser);
use vars '$time_view','$script_admin', '$ext', '$img_url', '$tmpl_dir', '$data', '$public_dir', '$use_emoticons', '$public_url', '$use_flock', '$dir', '%msg', '%in', '$builder',
'$index_url', '$index_page', '$entry_per_page', '$static_pages', '$view_cgi_url', '$site_title', '$how_news', '$use_search', '$not_found', '$foto_url',
'$premoderate', '$send_new_comments', '$admin_mail', '$SEND_MAIL', '$comadmin_cgi_url', '$comment_url', '$mail_cgi_url', '$coms_per_page', '$foto_dir', '$img_dir', '$GMT', '$upload_url', '$obj', '$autolink',
'$qhtml', '$fozzy', '$txt_news';
eval { 
require "cfg.cfg";
require "lang.pl"
};
#....If not Libraries
if ($@){
	print "Content-type: text/html\n\n";
	print "ERROR including libraries: $@";
	exit;
	}
	
#....RUN main subrouting	
eval {
&main
};
#....If Errors
if ($@){ 
&WLerr("Error: $@");
}
exit;


sub main {
#-------------------------------------------------------------------
$obj = new CGI;
my $url;
my $size_limit=0;#Max File size limit (bytes, eg $size_limit=1024*100; 100kb)
#If $size_limit=0; then unlimited.

unless ($obj->upload('upfile')){&WLerr(&form);}	
my($fh, $type, $filename, $b_read, $buf, $updir, $file, $size);
if ($obj->param('to') eq 'author'){$updir=$foto_dir; $url=$foto_url;}
else {
	$updir=$img_dir;
	$url=$img_url;
	}
$fh=$obj->upload('upfile');#GET Filehandle
$type=$obj->uploadInfo($fh)->{'Content-Type'};
#unless ($type eq )

$filename=$obj->param('upfile');
$filename=~tr/\\/\//;
if ($obj->param('newname')){$filename=$obj->param('newname');}
elsif ($filename=~/([^\/\\]+)$/){
	$filename=$1;
	}
else {&WLerr("Bad File name: $filename");}
&WLerr("Bad FileName: $filename!") if $filename=~/[^\w\.-]/;
$file=$updir."/$filename";
#TEST
&test_file($file, $filename);
open(WRFILE, ">$file"); 
binmode(WRFILE);
binmode($fh);
while ($b_read=read($fh,$buf,1024)){
	print WRFILE $buf;
	$size+=$b_read;
	#Checking File Size Limit
	if ($size_limit){
		if ($size_limit<$size){
			close WRFILE;
			unlink($file);
			&WLerr("Big File! Max Size: $size_limit (bytes)!");
		}	
	}
}
close WRFILE;
#Print Info:
&header_my;
print qq~
<h3>Info:</h3>
<li>Size: $size bytes
<li>File Name: $filename
<li>Content-Type: $type
<li>URL: <a href="$url/$filename">$url/$filename</a>
</body>
</html>
~;
}	

sub form {
#--------------------------------------------------------------
my $html= qq~
<H3>$msg{'menu_upload'}</H3>
<FORM action="$upload_url" ENCTYPE="multipart/form-data" method=POST> 
~;
$html .= qq~	
<INPUT name=upfile type=file style="background-color:#f0f0f0; border:#000000 1 solid; color:#000000; font-size: 8pt;"><BR>
~;
my $option=$obj->param('to');
if (($option)&&($option eq 'author')){$html .= qq~<input type=hidden name="to" value="author"~;}
else {
	$html .= qq~
		<font color="#b90000">
		<input type=radio name=to value=all checked>$msg{'upload_img'}
		<br><input type=radio name=to value=author>$msg{'upload_author'}
		<br></font>
	~;
}

if (@_){
$html .= qq~ Rename: <INPUT name=newname type=text value="$_[0]" style="background-color:#f0f0f0; border:#000000 1 solid; color:#000000; font-size: 8pt;"><BR>~;	
}
$html .= qq~
<INPUT type=submit value="Upload" style="background-color:#c0c0c0; border:#000000 1 solid; color:#000000; font-size: 8pt;"></FORM>
~;
return $html;
}

sub test_file {
#-------------------------------------------------------------
my $file=shift;
my $filename=shift;
my $html;
if (-e $file){
	$html= qq~
	<h3>Attention:</h3>
	File: <b>$file</b> now exists! Rename Your File!
	~;
	$html .=&form($filename);
	&WLerr($html);
}	
}	

sub WLerr {
#--------------------------------------------------------------
&header_my;
print @_;
exit;
}

sub header_my {
#--------------------------------------------------------------	
print "Content-type: text/html\n";
print "Pragma: no-cache\n\n";
print qq~
<html>
<head>
	<title>Sanitarium WebLoG - Upload File</title>
	$msg{'charset'}
</head>
<body bgcolor="#FFFFFF" text="#000000" link="#b90000" alink="#b90000">
~;

}

